//
//  iPhoneViewController.m
//  scummvm
//
//  Created by DotEmu on 09/04/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//
#import <sys/time.h>
#import <engines/engine.h>
#import <engines/igob/gob.h>
#import <engines/igob/goblin.h>
#import <engines/igob/script.h>
#import <engines/igob/hotspots.h>
#import <engines/igob/game.h>
#import "iPhoneViewController.h"
#import "hintViewController.h"
#import "menuigViewController.h"
#import "iphone_video.h"
#import "iphone_common.h"

//////////////////
//---GAME PARAMS
//GAME (GENERAL)
extern bool bMenuIngame;
extern bool bHintMenuActive;
extern bool bSleepMode;
extern bool bMouseModeOn;
extern bool bPopup;
extern bool bTutoOn;
extern UIButton* externMenuButton;
extern UIButton* externHintButton;
//SOUND
extern bool bSoundMusicActive;
extern int idSoundSFX;
extern AVAudioPlayer* audioPlayer;
//---END
////////////////

extern menuigViewController* g_menuigVC;

@implementation iPhoneViewController
@synthesize _hintVC, _menuigVC;


 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
/*- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil 
{

	
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad 
{
    [super viewDidLoad];
	
	// Emulated CD support through MP3
	NSURL *url = [NSURL fileURLWithPath:[NSString stringWithFormat:@"%@/button-28.mp3", [[NSBundle mainBundle] resourcePath]]];
	NSError *err;
	menuSFXPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:url error:&err];
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	menuSFXPlayer.numberOfLoops = 0;
}
 

// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation 
{
    // Return YES for supported orientations
    return ( interfaceOrientation == UIInterfaceOrientationLandscapeRight || interfaceOrientation == UIInterfaceOrientationLandscapeLeft );
}


- (void)didReceiveMemoryWarning 
{
	//NSLog(@"iPhoneViewController didReceiveMemoryWarning");	
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload
{
	//NSLog(@"iPhoneViewController viewDidUnload");	
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

- (void)dealloc 
{
	//NSLog(@"iPhoneViewController dealloc");	
    [super dealloc];	
	delete gg;
}

-(void)skipCopyright
{
	[(iPhoneView*)self.view addEvent:[[NSDictionary alloc] initWithObjectsAndKeys:[NSNumber numberWithInt:kButtonEscapeDown], @"type",
									  [NSNumber numberWithFloat:0.0f], @"x",[NSNumber numberWithFloat:0.0f], @"y",nil]];	
	[(iPhoneView*)self.view addEvent:[[NSDictionary alloc] initWithObjectsAndKeys:[NSNumber numberWithInt:kButtonEscapeUp], @"type",
									  [NSNumber numberWithFloat:0.0f], @"x",[NSNumber numberWithFloat:0.0f], @"y",nil]];
}

-(IBAction) escClickedDown
{
	NSLog(@"iPhoneViewController escClickedDown");		
	if( !bPopup )
		[(iPhoneView*)self.view addEvent:[[NSDictionary alloc] initWithObjectsAndKeys:[NSNumber numberWithInt:kButtonEscapeDown], @"type",
						 [NSNumber numberWithFloat:0.0f], @"x",[NSNumber numberWithFloat:0.0f], @"y",nil]];
}

-(IBAction) escClickedUp
{
	NSLog(@"iPhoneViewController escClickedUp");		
	if( !bPopup )
	{
		[(iPhoneView*)self.view addEvent:[[NSDictionary alloc] initWithObjectsAndKeys:[NSNumber numberWithInt:kButtonEscapeUp], @"type",
						 [NSNumber numberWithFloat:0.0f], @"x",[NSNumber numberWithFloat:0.0f], @"y",nil]];
		
		[[NSNotificationCenter defaultCenter] postNotificationName:@"loadingScreenOnNotif" object:nil];
		[NSTimer scheduledTimerWithTimeInterval:1.15 target:self selector:@selector(skipCopyright) userInfo:nil repeats:NO];	
	}
	else
	{
		if( bSoundMusicActive )
			[audioPlayer stop];
		[[NSNotificationCenter defaultCenter] postNotificationName:@"endAnimEndGameNotif" object:nil];		
	}
}

//help click button when down -> change the view to helpV
-(IBAction) helpClickedDown
{
	//NSLog(@"iPhoneViewController helpClickedDown");
	if( !bTutoOn )
	{
		[menuSFXPlayer stop];	
		menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
		[menuSFXPlayer play];
		
		if( !bMenuIngame && !bHintMenuActive )
		{
			bHintMenuActive = true;
			if( bSoundMusicActive )
				[audioPlayer pause];
			
			if (self._hintVC.view.superview == nil) 
			{ 
				hintViewController *iii = [[hintViewController alloc] initWithNibName:@"hintViewController" bundle:nil]; 
				self._hintVC = iii; 
				[iii release]; 
				
				self._hintVC.view.frame = CGRectMake( 0, self._hintVC.view.frame.size.height, self._hintVC.view.frame.size.width, self._hintVC.view.frame.size.height);
				[self.view addSubview:_hintVC.view]; 		
			}
			
			[self._hintVC.view setUserInteractionEnabled: NO];
			[UIView beginAnimations:nil context:self]; 
			{
				[UIView setAnimationDuration:1.0];
				[UIView setAnimationDelegate:self];
				[UIView setAnimationDidStopSelector:@selector(showHintMenuDidEnd:finished:context:)];
				[UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];
				
				self._hintVC.view.frame = CGRectMake( 0, 0, self._hintVC.view.frame.size.width, self._hintVC.view.frame.size.height );
			}
			[UIView commitAnimations];
		}
	}
}

-(void) showHintMenuDidEnd:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context
{
    [self._hintVC viewDidAppear: YES];
    [self._hintVC.view setUserInteractionEnabled: YES];
	bSleepMode = true;
	externMenuButton.enabled = NO;
	externHintButton.enabled = NO;	
}

-(void) pauseGame
{
	//NSLog(@"iPhoneViewController pauseGame");	
	bSleepMode = true;
	externMenuButton.enabled = NO;
	externHintButton.enabled = NO;	
}

-(IBAction) menuButtonClicked:(id)sender
{
	//NSLog(@"iPhoneViewController menuButtonClicked");
	if( !bTutoOn )
	{
		[menuSFXPlayer stop];	
		menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
		[menuSFXPlayer play];
		
		if( !bMenuIngame && !bHintMenuActive )
		{
			bMenuIngame = true;
			
			[[NSNotificationCenter defaultCenter] postNotificationName:@"clearAllNotif" object:nil];
			
			if( bMouseModeOn )
				[[NSNotificationCenter defaultCenter] postNotificationName:@"touchModeNotif" object:nil];
			
			if (self._menuigVC.view.superview == nil) 
			{ 
				menuigViewController *iii = [[menuigViewController alloc] initWithNibName:@"menuigViewController" bundle:nil]; 
				self._menuigVC = iii; 
				[iii release]; 
				
				self._menuigVC.view.frame = CGRectMake( 165, 10, 150, 250 );
				[self.view addSubview:_menuigVC.view]; 
				
				//v1.1.0 fix game over crash:
				g_menuigVC = self._menuigVC;
			}		
			[NSTimer scheduledTimerWithTimeInterval:0.25 target:self selector:@selector(pauseGame) userInfo:nil repeats:NO];
		}
	}
}

//ACCESSORS
- (hintViewController*) getHintVC 
{ 
	//NSLog(@"iPhoneViewController getHintVC");	
	return _hintVC; 
} 

- (void) setHintVC: (hintViewController*)iHintVC
{
	//NSLog(@"iPhoneViewController iHintVC");		
	[_hintVC autorelease]; 
	_hintVC = [iHintVC retain]; 
} 

-(Gob::GobEngine*) getGobEngine
{
	//NSLog(@"iPhoneViewController getGobEngine");	
	return gg;
}

@end
