//
//  settingsViewController.mm
//  scummvm
//
//  Created by DotEmu on 18/05/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "iPhoneViewController.h"
#import "menuigViewController.h"
#import "settingsViewController.h"
#import "Gob1MenuViewController.h"
#import <AudioToolbox/AudioServices.h>

//////////////////
//---GAME PARAMS
//GAME (GENERAL)
extern bool bFromMenuIngame;
extern bool bMenuIngame;
extern bool bMenuGob1;
extern bool bMouseModeOn;
//SOUND
extern int idSoundMusic;
extern int idSoundSFX;
extern AVAudioPlayer* audioPlayer;
extern AVAudioPlayer* menuPlayer;
extern UInt32 isiPodPlaying;
//DEFINES
extern menuigViewController* g_menuigVC;
extern iPhoneViewController* g_iVC;
//---END
////////////////

@implementation settingsViewController

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad 
{
	//NSLog(@"settingsViewController viewDidLoad");
	UInt32 propertySize = sizeof(isiPodPlaying);	
	OSStatus status = AudioSessionGetProperty(kAudioSessionProperty_OtherAudioIsPlaying, &propertySize, &isiPodPlaying);
	
	bWarning = false;
	m_sliderMusic.value = idSoundMusic;
	m_sliderSFX.value = idSoundSFX;	
	
	UIImage *stetchLeftTrack = [[UIImage imageNamed:@"slidefull.png"]
								stretchableImageWithLeftCapWidth:0.0 topCapHeight:0.0];
	UIImage *stetchRightTrack = [[UIImage imageNamed:@"slideempty.png"]
								 stretchableImageWithLeftCapWidth:0.0 topCapHeight:0.0];
	
	m_sliderMusic.backgroundColor = [UIColor clearColor];
	[m_sliderMusic setMinimumTrackImage:stetchLeftTrack forState:UIControlStateNormal];
	[m_sliderMusic setMaximumTrackImage:stetchRightTrack forState:UIControlStateNormal];
	[m_sliderMusic setThumbImage:[UIImage imageNamed:@"thumbSlide.png"] forState:UIControlStateNormal];
	[m_sliderMusic setThumbImage:[UIImage imageNamed:@"thumbSlide.png"] forState:UIControlStateHighlighted];	
	
	m_sliderSFX.backgroundColor = [UIColor clearColor];
	[m_sliderSFX setMinimumTrackImage:stetchLeftTrack forState:UIControlStateNormal];
	[m_sliderSFX setMaximumTrackImage:stetchRightTrack forState:UIControlStateNormal];
	[m_sliderSFX setThumbImage:[UIImage imageNamed:@"thumbSlide.png"] forState:UIControlStateNormal];
	[m_sliderSFX setThumbImage:[UIImage imageNamed:@"thumbSlide.png"] forState:UIControlStateHighlighted];	
	
	// Emulated CD support through MP3
	NSURL *url = [NSURL fileURLWithPath:[NSString stringWithFormat:@"%@/button-28.mp3", [[NSBundle mainBundle] resourcePath]]];
	NSError *error;
	menuSFXPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:url error:&error];
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	menuSFXPlayer.numberOfLoops = 0;
	
	url = [NSURL fileURLWithPath:[NSString stringWithFormat:@"%@/clicker.mp3", [[NSBundle mainBundle] resourcePath]]];
	controlClick = [[AVAudioPlayer alloc] initWithContentsOfURL:url error:&error];
	controlClick.volume = (float)((float)idSoundSFX / 256.0f);
	controlClick.numberOfLoops = 0;
	
	//control mode
	m_controlMode = [[UIButton buttonWithType:UIButtonTypeCustom] retain];
	m_controlMode.frame = CGRectMake( 240, 210, 137, 80 );	
	if( bMouseModeOn )
	{
		[m_controlMode setImage:[UIImage imageNamed:@"settings_cursor_mode.png"] forState:UIControlStateNormal];
		[m_controlMode setImage:[UIImage imageNamed:@"settings_cursor_enf.png"] forState:UIControlStateHighlighted];
	}
	else
	{
		[m_controlMode setImage:[UIImage imageNamed:@"settings_touch_mode.png"] forState:UIControlStateNormal];	
		[m_controlMode setImage:[UIImage imageNamed:@"settings_touch_enf.png"] forState:UIControlStateHighlighted];		
	}
	[m_controlMode addTarget:self action:@selector(touchModeClicked:) forControlEvents:UIControlEventTouchUpInside];	
	m_controlMode.hidden = NO;
	[self.view addSubview:m_controlMode];	
	
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(settingsMusicNotification)  name:@"settingsMusicNotif" object:nil];
	
    [super viewDidLoad];
}

// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return ( interfaceOrientation == UIInterfaceOrientationLandscapeRight || interfaceOrientation == UIInterfaceOrientationLandscapeLeft );
}

- (void)didReceiveMemoryWarning
{
	//NSLog(@"settingsViewController didReceiveMemoryWarning");
	
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
	bWarning = true;
	
	[menuSFXPlayer stop];
	if( menuSFXPlayer != nil )
	{
		[menuSFXPlayer release];
		menuSFXPlayer = nil;
	}
}

- (void)viewDidUnload 
{
	//NSLog(@"settingsViewController viewDidUnload");	
	
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
	if( m_sliderMusic != nil )
	{
		[m_sliderMusic release];
		m_sliderMusic = nil;
	}
	if( m_sliderSFX != nil )
	{
		[m_sliderSFX release];
		m_sliderSFX = nil;
	}
}

- (void)dealloc
{
	//NSLog(@"settingsViewController dealloc");		
    [super dealloc];
	
	if( m_sliderMusic != nil )
	{
		[m_sliderMusic release];
		m_sliderMusic = nil;
	}
	if( m_sliderSFX != nil )
	{
		[m_sliderSFX release];
		m_sliderSFX = nil;
	}
}

-(void)settingsMusicNotification
{
	[self performSelectorOnMainThread:@selector(settingsMusic) withObject: nil waitUntilDone:NO];	
}

-(void)settingsMusic
{
	m_sliderMusic.value = idSoundMusic;
}

- (void)animationFinished:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context 
{
	[self.view removeFromSuperview];
	
	if( bMenuGob1 )
	{
		if( !bWarning )
			[[NSNotificationCenter defaultCenter] postNotificationName:@"animationN" object:nil];	
		else
			bWarning = false;
	}
	else
	{
		bMenuIngame = true;
		bFromMenuIngame = false;
	}
}

-(IBAction) menuClicked:(id)sender
{
	//NSLog(@"settingsViewController menuClicked");
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];

	[UIView beginAnimations:nil context:self]; 
	{
		[UIView setAnimationDuration:1.0];
		[UIView setAnimationDelegate:self];
		[UIView setAnimationDidStopSelector:@selector(animationFinished:finished:context:)];
		[UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];	
		self.view.frame = CGRectMake( self.view.frame.size.width, 0, self.view.frame.size.width, self.view.frame.size.height );
	}
	[UIView commitAnimations];
	
	if( bFromMenuIngame && !bMenuGob1 )
	{
		[g_iVC.view addSubview:g_menuigVC.view];
	}
	
	if( !bMenuGob1 )
	{
		if( !isiPodPlaying )
		{
			[[NSNotificationCenter defaultCenter] postNotificationName:@"setSoundsNotif" object:nil];	
		}
	}
	
	if( isiPodPlaying && [[[UIDevice currentDevice] model] isEqualToString:@"iPhone"] )
	{
		idSoundMusic = m_sliderMusic.value = 0;		
	}
	
	audioPlayer.volume = (float)((float)idSoundMusic / 256.0f);
	menuPlayer.volume = (float)((float)idSoundMusic / 256.0f);
}

-(IBAction) saveSoundMusicValue:(id)sender
{
	//NSLog(@"settingsViewController saveSoundMusicValue");		
	idSoundMusic = m_sliderMusic.value;
	
	if( !bMenuGob1 )
	{
		if( !isiPodPlaying )
		{
			[[NSNotificationCenter defaultCenter] postNotificationName:@"setSoundsNotif" object:nil];	
		}
	}
	
	if( isiPodPlaying && [[[UIDevice currentDevice] model] isEqualToString:@"iPhone"] )
	{
		idSoundMusic = m_sliderMusic.value = 0;		
	}
	
	audioPlayer.volume = (float)((float)idSoundMusic / 256.0f);
	menuPlayer.volume = (float)((float)idSoundMusic / 256.0f);
}

-(IBAction) saveSoundSFXValue:(id)sender
{
	//NSLog(@"settingsViewController saveSoundSFXValue");	
	idSoundSFX = m_sliderSFX.value;
	
	audioPlayer.volume = (float)((float)idSoundMusic / 256.0f);
	menuPlayer.volume = (float)((float)idSoundMusic / 256.0f);
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	[[NSNotificationCenter defaultCenter] postNotificationName:@"setSoundsNotif" object:nil];	
}

-(IBAction) touchModeClicked:(id)sender
{
	//NSLog(@"settingsViewController touchModeClicked");	
	[controlClick stop];	
	controlClick.volume = (float)((float)idSoundSFX / 256.0f);
	[controlClick play];
	
	bMouseModeOn = !bMouseModeOn;
	
	[m_controlMode removeFromSuperview];

	if( bMouseModeOn )
	{
		[m_controlMode setImage:[UIImage imageNamed:@"settings_cursor_mode.png"] forState:UIControlStateNormal];
		[m_controlMode setImage:[UIImage imageNamed:@"settings_cursor_enf.png"] forState:UIControlStateHighlighted];		
		[[NSNotificationCenter defaultCenter] postNotificationName:@"cursorModeNotif" object:nil];
	}
	else
	{
		[m_controlMode setImage:[UIImage imageNamed:@"settings_touch_mode.png"] forState:UIControlStateNormal];	
		[m_controlMode setImage:[UIImage imageNamed:@"settings_touch_enf.png"] forState:UIControlStateHighlighted];			
		[[NSNotificationCenter defaultCenter] postNotificationName:@"touchModeNotif" object:nil];		
	}
	[self.view addSubview:m_controlMode];	
}

@end
